'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'bulkoperate.vbs - connect to the WMI service of
'each machine in a domain in turn, so that WMI
'operations may be performed
Option Explicit
On Error Resume Next
Dim refWMI
Dim colComputers
Dim refComputer
Dim refHostWMI
Dim strMoniker

'first connect to LDAP namespace on local machine
Set refWMI = GetObject("winMgmts:root\directory\LDAP")
If Err <> 0 Then
	WScript.Echo "Oh dear. I cannot connect to the LDAP namespace"
	WScript.Quit
End If

'retrieve all DS_computer objects. Attempt to connect to WMI
'on each, using DS_dNSHostName
Set colComputers = refWMI.ExecQuery("SELECT * FROM DS_computer")
For Each refComputer in colComputers
	strMoniker = "winMgmts:\\" & refComputer.DS_dNSHostName
	Set refHostWMI = GetObject(strMoniker)
	If Err <> 0 Then
		WScript.Echo "Could not connect to " & refComputer.DS_cn
		Err.Clear
	Else
		WScript.Echo "Connected to " & refComputer.DS_cn
		CarryOutActions refWMI
	End If
Next

'tidy up
Set refWMI = Nothing

'fill in the body of this subroutine with
'useful code. It is called once for every machine in the domain.
Sub CarryOutActions(refWMI)
	WScript.Echo "Doing useful things..."
End Sub
