'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'checkowner.vbs - outputs the owner name of a file passed as a command-line
'parameter, or gives an error if it cannot
Option Explicit
On Error Resume Next
Dim refWMI
Dim strQuery
Dim colOwner
Dim refItem

'check command-line argument seems sane
If WScript.Arguments.Count <> 1 Then
	WScript.Echo"Usage: checkowner.vbs <path>"
	WScript.Quit
End If

'connect to WMI or quit with error
set refWMI = GetObject("winMgmts:")
If Err <> 0 Then
	WScript.Echo "Oh dear. Could not connect to WMI. Error: " & Err.Description
	WScript.Quit
End If

'get reference
strQuery = "ASSOCIATORS OF {Win32_LogicalFileSecuritySetting=" & _
	"'" & WScript.arguments.item(0) & "'} WHERE " & _
	"AssocClass=Win32_LogicalFileOwner " & _
	"ResultRole=Owner"
set colOwner = refWMI.ExecQuery(strQuery)

'finally, read the owner info from Win32_SID
For Each refItem In colOwner
	If Err = 0 Then
		WScript.Echo WScript.arguments.item(0) & " is owned by " &
			refItem.AccountName
	Else
		WScript.Echo "Cannot find owner for " & WScript.arguments.item(0)
	End If
Next
Set colOwner = Nothing
set refWMI = Nothing
