'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'dirsize.vbs - prints the size of all directories on a system
Option Explicit
Dim refWMIService
Dim strDirName
Dim refDirectory

'put the name of the directory you wish to find the size of here
strDirName="c:\program files"

'get reference to WMI. Also get a direct reference to the directory
'we want to know about
set refWMIService = GetObject("winMgmts:")
set refDirectory = GetObject("winMgmts:Win32_Directory='" & strDirName & "'")

'fire our recursive function and display results
WScript.echo "Size of " & strDirName & " is " & _
	getDirectorySize(refDirectory) & " bytes."

'clean up
set refDirectory = Nothing
set refWMIService = Nothing

'------- End of script --------

'This function returns the aggregated size
'of all files in a directory and its subdirectories
Function getDirectorySize(pCurrentDir)
Dim numFSize
Dim numDSize
Dim strQuery
Dim refItem
Dim colFiles
Dim colSubdirs
numFSize = 0
numDSize = 0

'first get a reference to all files in the directory
strQuery = "ASSOCIATORS OF {Win32_Directory='" & _
		pCurrentDir.Name & "'} WHERE " & _
		"AssocClass=CIM_DirectoryContainsFile " & _
		"Role=GroupComponent ResultRole=PartComponent"
set colFiles = refWMIService.ExecQuery(strQuery)

'loop through each file and add the size of each to numFSize
For Each refItem In colFiles
	numFSize = numFSize + refItem.FileSize
Next
set colFiles = Nothing

'now get a reference to all the subdirectories
strQuery = "ASSOCIATORS OF {Win32_Directory='" & _
		pCurrentDir.Name & "'} WHERE " & _
		"AssocClass=Win32_SubDirectory " & _
		"ResultRole=PartComponent"
set colSubDirs = refWMIService.ExecQuery(strQuery)

'loop through each subdirectory, and add its
'size to numDSize by recursively calling this function
For Each refItem in colSubDirs
	numDSize = numDSize + getDirectorySize(refItem)
Next
set colSubdirs = Nothing

'finally, print stats and return the total size
WScript.echo pCurrentDir.Name & ": " & numFSize & _
		" bytes in files - " & numDSize & _
		" bytes in subdirs"
getDirectorySize = numFSize + numDSize

End Function
