'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'fullcontrol.vbs - gives full control over a given file or directory
'to a given account, but only if that account already exists within the DACL
Option Explicit
On Error Resume Next
Dim refSetting
Dim refSD
Dim refItem
Dim boolFoundIt

'check that command-line arguments are same
If WScript.arguments.count <> 2 Then
	WScript.Echo "Usage: fullcontrol.vbs <object> <account>"
	WScript.quit
End If

'try to retrieve a Win32_LogicalFileSecuritySetting for the file
'or directory in question
Set refSetting = GetObject("winMgmts:{(Security,Restore)}"& _
	"Win32_LogicalFileSecuritySetting='" &_
WScript.arguments.item(0) & "'")
If Err <> 0 Then
	WScript.Echo "Cannot get security for " & WScript.arguments.item(0)
	WScript.quit
End If

If refSetting.GetSecurityDescriptor(refSD) = 0 Then
	'loop through the DACL. If we find an entry for the given
	'account, change its AccessMask to full control and set
	'boolFoundIt to true
	boolFoundIt = False
	For Each refItem In refSD.DACL
		If refItem.Trustee.Name = WScript.arguments.item(1) Then
			refItem.AccessMask = 2032127
			boolFoundIt = True
		End If
	Next
	'if there was no appropriate DACL entry, report failure
	If Not boolFoundIt Then
		WScript.Echo "Could not find an ACE for " & _ WScript.arguments.item(1)
	Else
		'try to write back security descriptor and report success
		'or failure
		If refSetting.SetSecurityDescriptor(refSD) = 0 Then
			Security Representation Within WMI 33
			WScript.Echo "Security Descriptor changed successfully"
		Else
			WScript.Echo "Failed to write back changed security descriptor"
		End If
	End If
Else
	'oh dear - could not get SD
	WScript.Echo "Cannot retrieve Security Descriptor"
End If
Set refSetting = Nothing
