'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'logeventdelivery.vbs - register to receive notification
'of new entries in the Event Log. Report the first entry
'that occurs
Option Explicit
Dim refWMI
Dim refEventSource
Dim strQuery
Dim refEvent

'connect to WMI with privileges needed to get events
'from the Security Event Log
Set refWMI = GetObject("winMgmts:{(security)}")

'prepare WQL event query
strQuery = "SELECT * FROM __InstanceCreationEvent " & _
	"WHERE TargetInstance ISA 'Win32_NTLogEvent'"

'pass the query to ExecNotificationQuery to get a reference
'to an SWbemEventSource
Set refEventSource = refWMI.ExecNotificationQuery(strQuery)

'make the blocking call to NextEvent.
'This line will remain blocked until WMI can return
'an __InstanceCreationEvent matching our criteria
Set refEvent = refEventSource.NextEvent()

'if we get here, an entry must have been written in the
'Event Log. Display the source name and Message
WScript.Echo refEvent.TargetInstance.SourceName & _
	" has just registered an Event. Details: " & _
	refEvent.TargetInstance.Message

'clean up
Set refEvent = Nothing
Set refEventSource = Nothing
Set refWMI = Nothing
