'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'productreport.vbs - create a simple report listing all products
'installed on a machine under the control of the Windows Installer
Option Explicit
On Error Resume Next
Dim refReport
Dim refWMI
Dim colInstProducts
Dim refProduct

'Initialize report
Set refReport = CreateObject("WMIBook.SimpleReport")
refReport.title = "Software on my computer"
refReport.comment = "This report lists all the software " & _
	"products installed on my computer under the control " & _
	"of the Windows Installer"

'connect to WMI and retrieve collection of Win32_Products
Set refWMI = GetObject("winmgmts:")
If Err <> 0 Then
	WScript.Echo "Could not connect to WMI"
	WScript.Quit
End If

Set colInstProducts = refWMI.InstancesOf("Win32_Product")

'Loop through Products adding report entries
For Each refProduct in colInstProducts
	refReport.addEntry refProduct.Name, _
		refProduct.Name, _
		"Version: " & refProduct.Version & "<br>" & _
		"IndentifyingNumber: " & refProduct.IdentifyingNumber & _
		"<br>" & "Description: " & refProduct.Description
Next

refReport.browse("c:\temp\mysoftware.html")

Set ColInstProducts = Nothing
Set refWMI = Nothing
Set refReport = Nothing
