'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'setdefaultwallpaper.vbs  set the default wallpaper of a remote machine
Option Explicit
On Error Resume Next
Dim refRegistry
Dim strSKPath
Dim strMoniker
Dim strMachineName
Dim StrWallPaper
Dim i

'set symbolic constant
Const HKEY_USERS = &H80000003

'check cmd-line args for sanity
If WScript.Arguments.Count <> 2 Then
	WScript.Echo "Usage: SetWallpaper.vbs <Machine> <wallpaper path>"
	WScript.Quit
End If

'prepare variables for writing value
strSKPath = ".default\Control Panel\Desktop"
strMachineName = WScript.Arguments(0)
strWallPaper = WScript.Arguments(1)

'attempt to retrieve remote StdRegProv
strMoniker = "winMgmts:\\" & strMachineName & "\root\default:StdRegProv"
Set refRegistry = GetObject(strMoniker)
If Err<>0 Then
	WScript.Echo "Unable to locate registry - on " & strMachineName
	WScript.Quit
End If

'Set the WallPaper
If refRegistry.SetStringValue( _
 HKEY_USERS, strSKPath , "WallPaper" ,strWallPaper) = 0 Then
	WScript.Echo "Wall paper Set on " & strMachineName
Else
	WScript.Echo "Unable to set wallpaper on " & strMachineName
End If

'set wallpaper so that it is tiled
If refRegistry.SetStringValue( _
 HKEY_USERS , strSKPath , "TileWallpaper" ,1) = 0 Then
	WScript.Echo "Set wall paper to tiled on " & strMachineName
Else
	WScript.Echo "Unable to tile wallpaper on " & strMachineName
End If

Set refRegistry = Nothing
